package org.example.file;

public class Util {

    /**
     * Converts the given string to double, without Exception.
     * The default value is used if the given value is null or invalid.
     * @param sVal value to convert 
     * @param dDefaultValue : Default value if the string is null or contains an invalid value
     * @return the numeric value after parsing
     */
    public static double getDouble(final String sVal, final double dDefaultValue )
    {
        if (sVal == null)
        {
            return dDefaultValue ;
        }

        try
        {
            return Double.parseDouble(sVal.trim());
        }
        catch (NumberFormatException ex)
        {
            return dDefaultValue;
        }
    }
	
}
