package org.example.file.csv;
import java.util.LinkedList;
import java.util.List;

import org.example.file.Book;
import org.example.file.Util;
import org.objectweb.telosys.util.file.CSVFileParser;


/**
 * This class is a handler to process each line of a CVS file
 * 
 * @author L. Guerin
 *
 */
public class CsvToBooksParser extends CSVFileParser
{
	private LinkedList<Book> books = new LinkedList<Book>();
	
	public CsvToBooksParser() 
	{
		super("|", "#");
	}
	
    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#start()
     */
    public void start()
    {
        System.out.println("Start : nothing to do");
    }
    
    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#voidLine(int)
     */
    public void voidLine( int no )
    {
        System.out.println("Void ("+no+") : nothing to do");
    }
    
    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#commentLine(int, java.lang.String)
     */
    public void commentLine( int no, String sLine )
    {
        System.out.println("Comment ("+no+") : nothing to do");
    }
    
    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#dataLine(int, java.lang.String, java.lang.String[])
     */
    public void dataLine( int n, String sLine, String fields[] )
    {
    	if ( fields.length < 4 )
    	{
    		System.out.println("Invalid line : at least 4 fields expected, " + fields.length + " field(s) received");
    	}
    	else
    	{
        	//Book book = new Book(fields[0], fields[1], fields[2], StrUtil.getDouble(fields[3],0.0) );
        	Book book = new Book();

        	book.setTitle(fields[0]);
        	book.setAuthorLastName(fields[1]);
        	book.setAuthorFirstName(fields[2]);
        	book.setPrice( Util.getDouble(fields[3],0.0) );
        	
        	books.add(book);
            System.out.println("Book " + n + " ");
    	}
    }

    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#end()
     */
    public void end()
    {
        System.out.println("End");
        
    }

	@Override
	public List<?> getResult() {
		// TODO Auto-generated method stub
		return books;
	}

}
