package org.example.file.csv;
import java.util.List;

import org.objectweb.telosys.util.file.CSVFileParser;


/**
 * This class is a handler to process each line of a CVS file
 * 
 * @author L. Guerin
 *
 */
public class CsvToXmlParser extends CSVFileParser
{
	public CsvToXmlParser() 
	{
		super("|", "#");
	}

    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#start()
     */
    public void start()
    {
        System.out.println("<?xml version=\"1.0\" ?>");
        System.out.println("<root>");
    }
    
    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#voidLine(int)
     */
    public void voidLine( int no )
    {
        System.out.println(" <!-- Void (" + no + ") -->");
    }
    
    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#commentLine(int, java.lang.String)
     */
    public void commentLine( int no, String sLine )
    {
        System.out.println(" <!-- Comment ("+no+") : " + sLine + "-->");
    }
    
    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#dataLine(int, java.lang.String, java.lang.String[])
     */
    public void dataLine( int n, String sLine, String fields[] )
    {
        System.out.println(" <row id=\"" + n + "\" >");
        for ( int i = 0 ; i < fields.length ; i++ )
        {
            System.out.print("  <col"+i+">");
            System.out.print( fields[i]);
            System.out.println("</col"+i+">");
        }
        System.out.println(" </row>");
        
    }

    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#end()
     */
    public void end()
    {
        System.out.println("</root>");
        System.out.println("Fin");
        
    }

	@Override
	public List<?> getResult() {
		return null; // Nothing to return 
	}

}
