package org.example.file.text;
import java.util.LinkedList;
import java.util.List;

import org.example.file.Book;
import org.example.file.Util;
import org.objectweb.telosys.util.file.TextFileParser;


/**
 * This class is a handler to process each line of a CVS file
 * 
 * @author L. Guerin
 *
 */
public class TextToBooksParser extends TextFileParser
{
	private LinkedList<Book> books = new LinkedList<Book>();
	
	public TextToBooksParser() 
	{
		super("#");
	}

    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#start()
     */
    public void start()
    {
        System.out.println("Start : nothing to do");
    }
    
    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#voidLine(int)
     */
    public void voidLine( int no )
    {
        System.out.println("Void ("+no+") : nothing to do");
    }
    
    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#commentLine(int, java.lang.String)
     */
    public void commentLine( int no, String sLine )
    {
        System.out.println("Comment ("+no+") : nothing to do");
    }
    
	@Override
	public void dataLine(int n, String sLine) {
		if ( sLine.length() > 40 ) {
			;
        	Book book = new Book();

        	book.setTitle          ( sLine.substring( 0, 20).trim() );
        	book.setAuthorLastName ( sLine.substring(20, 30).trim() );
        	book.setAuthorFirstName( sLine.substring(30, 40).trim() );
        	book.setPrice( Util.getDouble(sLine.substring(40),0.0) );
        	
        	books.add(book);
            System.out.println("Book " + n + " ");
		}
		else {
    		System.out.println("Invalid line : length < 40");
		}
	}

    /* (non-Javadoc)
     * @see org.objectweb.telosys.dal.csv.ICSVHandler#end()
     */
    public void end()
    {
        System.out.println("End");
        
    }

	@Override
	public List<?> getResult() {
		// TODO Auto-generated method stub
		return books;
	}


}
